--Declaring
ProfessionBars = LibStub("AceAddon-3.0"):NewAddon("ProfessionBars", "AceEvent-3.0", "AceTimer-3.0")
profbars_options = {
	name = "ProfessionBars",
	handler = ProfessionBars,
	type = 'group',
	args = {
		mode = {
			type = 'input',
			name = 'Mode',
			desc = 'Set the Mode PB runs in. Mode 1 means that the bars are seperate and draggable. Mode 2 means that the bars are attached to the Tradeskill Window.',
			set = 'SetMode',
			get = 'GetMode',
		},
		help = {
			type = 'input',
			name = 'Help',
			desc = 'Turns help On/Off',
			set = 'ToggleHelp',
			get = 'GetMode',
		},
	},
}

local function SearchPlayerBags(itemID, occurance)
	--print("-------------");
	local found = 0;
	for i=0, 4 do
		local a = GetContainerNumSlots(i)
		for c=1, a do
			local link = GetContainerItemLink(i, c);
			local name = GetItemInfo(itemID);
			if link then
				if string.match(link, name) then
					found = found+1;
					--print("Occurance "..found..": Bag "..i..", Slot "..c..": Item is "..link..".");
					if found == occurance then
						--print("-------------");
						return i, c
					end
				end
			end
		end
	end
	--print("-------------");
	return nil
end

local function OnTooltipShow(self, frame)
	local a = frame:GetName()
	if a == "profbars_jcbutton1" then
		self:SetHyperlink("item:23425:0:0:0:0:0:0:0");
		self:AddLine(" ");
		self:AddLine("Prospecting Results: ");
		self:AddDoubleLine("100%", "Adamantite Powder");
		self:AddDoubleLine("19%", "Uncommon Outland gems");
		self:AddDoubleLine("3%", "Rare Outland gems");
		self:AddLine("Note: Always results in at least one uncommon gem");
	elseif a == "profbars_jcbutton2" then
		self:SetHyperlink("item:36909:0:0:0:0:0:0:0");
		self:AddLine(" ");
		self:AddLine("Prospecting Results: ");
		self:AddDoubleLine("25%:", "Uncommon Northrend gems");
		self:AddDoubleLine("1.3%:", "Rare Northrend gems");
		self:AddLine("Note: Always results in at least one uncommon gem");
	elseif a == "profbars_jcbutton3" then
		self:SetHyperlink("item:36912:0:0:0:0:0:0:0");
		self:AddLine(" ");
		self:AddLine("Prospecting Results: ");
		self:AddDoubleLine("20%:", "Uncommon Northrend gems");
		self:AddDoubleLine("4%:", "Rare Northrend gems");
		self:AddLine("Note: Always results in at least one uncommon gem");
	elseif a == "profbars_jcbutton4" then
		self:SetHyperlink("item:23424:0:0:0:0:0:0:0");
		self:AddLine(" ");
		self:AddLine("Prospecting Results: ");
		self:AddDoubleLine("17%:", "Uncommon Outland gems");
		self:AddDoubleLine("1.1%:", "Rare Outland gems");
		self:AddLine("Note: Always results in at least one uncommon gem");
	elseif a == "profbars_jcbutton5" then
		self:SetHyperlink("item:10620:0:0:0:0:0:0:0")
		self:AddLine(" ");
		self:AddLine("Prospecting Results: ");
		self:AddDoubleLine("25%:", "Star Ruby");
		self:AddDoubleLine("20%:", "Blue Sapphire");
		self:AddDoubleLine("20%:", "Large Opal");
		self:AddDoubleLine("20%:", "Azerothian Diamond");
		self:AddDoubleLine("1%:", "Uncommon Outland gems");
	elseif a == "profbars_jcbutton6" then
		self:SetHyperlink("item:3858:0:0:0:0:0:0:0");
		self:AddLine(" ");
		self:AddLine("Prospecting results: ");
		self:AddDoubleLine("37.5%", "Star Ruby");
		self:AddDoubleLine("37.5%", "Citrine");
		self:AddDoubleLine("37.5%", "Aquamarine");
		self:AddDoubleLine("3%", "Azerothian Diamond");
		self:AddDoubleLine("3%", "Large Opal");
		self:AddDoubleLine("3%", "Huge Emerald");
		self:AddDoubleLine("3%", "Blue Sapphire");
	elseif a == "profbars_jcbutton7" then
		self:SetHyperlink("item:2772:0:0:0:0:0:0:0");
		self:AddLine(" ");
		self:AddLine("Prospecting results: ");
		self:AddDoubleLine("37.5%", "Lesser Moonstone");
		self:AddDoubleLine("37.5%", "Citrine");
		self:AddDoubleLine("37.5%", "Jade");
		self:AddDoubleLine("5%", "Star Ruby");
		self:AddDoubleLine("5%", "Aquamarine");
	elseif a == "profbars_jcbutton8" then
		self:SetHyperlink("item:2771:0:0:0:0:0:0:0");
		self:AddLine(" ");
		self:AddLine("Prospecting results: ");
		self:AddDoubleLine("37.5%", "Lesser Moonstone");
		self:AddDoubleLine("37.5%", "Shadowgem");
		self:AddDoubleLine("37.5%", "Moss Agate");
		self:AddDoubleLine("4%", "Citrine");
		self:AddDoubleLine("4%", "Jade");
		self:AddDoubleLine("4%", "Aquamarine");
	elseif a == "profbars_jcbutton9" then
		self:SetHyperlink("item:2770:0:0:0:0:0:0:0");
		self:AddLine(" ");
		self:AddLine("Prospecting results: ");
		self:AddDoubleLine("50%", "Malachite");
		self:AddDoubleLine("50%", "Tigerseye");
		self:AddDoubleLine("10%", "Shadowgem");
	elseif a == "profbars_inscbutton1" then
		self:SetHyperlink("item:39342:0:0:0:0:0:0:0");
		-- self:AddLine("Herbs milled:");
		-- self:AddDoubleLine("Ancient Lichen", "Dreaming Glory");
		-- self:AddDoubleLine("Felweed", "Mana Thistle");
		-- self:AddDoubleLine("Netherbloom", "Nightmare Vine");
		-- self:AddDoubleLine("Ragveil", "Terocone");
	elseif a == "profbars_inscbutton2" then
		self:SetHyperlink("item:39343:0:0:0:0:0:0:0");
		-- self:AddLine("Herbs milled:");
		-- self:AddDoubleLine("Adder's Tongue", "Deadnettle");
		-- self:AddDoubleLine("Fire Leaf", "Goldclover");
		-- self:AddDoubleLine("Icethorn", "Lichbloom");
		-- self:AddDoubleLine("Talandra's Rose", "Tiger Lily");
	elseif a == "profbars_inscbutton4" then
		self:SetHyperlink("item:39341:0:0:0:0:0:0:0");
		-- self:AddLine("Herbs milled:");
		-- self:AddDoubleLine("Dreamfoil", "Golden Samsam");
		-- self:AddDoubleLine("Icecap", "Mountain Silversage");
		-- self:AddDoubleLine("Plaguebloom", "");
	elseif a == "profbars_inscbutton5" then
		self:SetHyperlink("item:39340:0:0:0:0:0:0:0");
		-- self:AddLine("Herbs milled:");
		-- self:AddDoubleLine("Arthas' Tears", "Blindweed");
		-- self:AddDoubleLine("Firebloom", "Ghost Mushroom");
		-- self:AddDoubleLine("Gromsblood", "Purple Lotus");
		-- self:AddDoubleLine("Sungrass", "");
	elseif a == "profbars_inscbutton6" then
		self:SetHyperlink("item:39339:0:0:0:0:0:0:0");
		-- self:AddLine("Herbs milled:");
		-- self:AddDoubleLine("Fadeleaf", "Goldthorn");
		-- self:AddDoubleLine("Khadgar's Whisker", "Wintersbite");
	elseif a == "profbars_inscbutton7" then
		self:SetHyperlink("item:39338:0:0:0:0:0:0:0");
		-- self:AddLine("Herbs milled:");
		-- self:AddDoubleLine("Grave Moss", "Kingsblood");
		-- self:AddDoubleLine("Liferoot", "Wild Steelbloom");
	elseif a == "profbars_inscbutton8" then
		self:SetHyperlink("item:39334:0:0:0:0:0:0:0");
		-- self:AddLine("Herbs milled:");
		-- self:AddDoubleLine("Briarthorn", "Bruiseweed");
		-- self:AddDoubleLine("Mageroyal", "Stranglekelp");
		-- self:AddDoubleLine("Swiftthistle", "");
		local c
		for i=1, GetNumSkillLines() do
			local name,_,_, level = GetSkillLineInfo(i);
			if name==GetSpellInfo(45357) then
				c = level;
			end
		end
		if c < 25 and c >=1 then
			self:AddLine(" ");
			self:AddLine("All herbs except Mageroyal require Inscription skill 25 to mill");
		end
	elseif a == "profbars_inscbutton9" then
		self:SetHyperlink("item:39151:0:0:0:0:0:0:0");
		-- self:AddLine("Herbs milled:");
		-- self:AddDoubleLine("Earthroot", "Peacebloom");
		-- self:AddDoubleLine("Silverleaf", "");
	end
	if not profbars_data.help then
		self:AddLine("Left-Click to mill for the highest number of Pigments, Right-Click to mill for the lowest");
	end
end

local function OnEnter(self)
	GameTooltip:SetOwner(self, "ANCHOR_NONE");
	GameTooltip:ClearAllPoints();
	GameTooltip:SetPoint("TOPLEFT", self, "BOTTOMLEFT");
	GameTooltip:ClearLines()
	OnTooltipShow(GameTooltip, self)
	GameTooltip:Show()
end

local function OnLeave(self)
	GameTooltip:Hide();
end

local function PlayerHasSpell(spellID)
	local a = GetSpellInfo(spellID);
	local b = GetSpellInfo(a);
	if b then
		return true
	else
		return false
	end
end

function ProfessionBars:ToggleHelp(info, input)
	if input then
		if input == "on" then
			profbars_data.help = false;
		elseif input == "off" then
			profbars_data.help = true;
		elseif profbars_data.help then
			profbars_data.help = false;
		else
			profbars_data.help = true;
		end
	elseif profbars_data.help then
		profbars_data.help = false;
	else
		profbars_data.help = true;
	end
	if profbars_data.help then
		print("ProfessionBars help turned off");
	else
		print("ProfessionBars help turned on");
	end
end

function ProfessionBars:SetMode(info, input)
	local a = tonumber(input);
	if not (a==1 or a==2) then
		print("ProfessionBars is currently running in Mode "..profbars_data.mode);
	else
		local b
		if profbars_data.mode == a then
			b = true;
		else
			b = false;
		end
		profbars_data.mode = a;
		print("ProfessionBars is now running in mode "..a);
		if profbars_data.mode == 1 then
			ProfessionBars:PLAYER_ENTERING_WORLD()
		else
			if PlayerHasSpell(25229) then
				profbars_jcmove:Hide();
				profbars_jewelcrafting:Hide();
				profbars_jewelcrafting:SetWidth(profbars_jewelcrafting:GetWidth()-17.5);
			end
			if PlayerHasSpell(45357) then
				profbars_inscmove:Hide();
				profbars_inscription:Hide();
				profbars_inscription:SetWidth(profbars_inscription:GetWidth()-17.5);
			end
		end
	end
end

function ProfessionBars:GetMode()
	return profbars_data.mode
end

function ProfessionBars:insc_showhide(level)
	--This function is no longer used and replaced by ProfessionBars:ITEM_PUSH. This is in case I forgot to replace some uses.
	ProfessionBars:ITEM_PUSH();
end

function ProfessionBars:jc_showhide(level)
	--This function is no longer used and replaced by ProfessionBars:ITEM_PUSH. This is in case I forgot to replace some uses.
	ProfessionBars:ITEM_PUSH();
end

local function GetNumStacks(itemID)
	local found = 0;
	for i=0, 4 do
		local a =GetContainerNumSlots(i)
		for c=1, a do
			local link = GetContainerItemLink(i, c);
			local name = GetItemInfo(itemID);
			if link then
				if string.match(link, name) then
					found = found+1;
				end
			end
		end
	end
	return found
end

function ProfessionBars:OnInitialize()
	if not profbars_data then
		profbars_data = {};
	end
	if not profbars_data.mode then
		profbars_data.mode = 2;
	end
	LibStub("AceConfig-3.0"):RegisterOptionsTable("ProfessionBars", profbars_options, {"profbars", "professionbars"});
end

function ProfessionBars:OnEnable()
	self:RegisterEvent("PLAYER_ENTERING_WORLD");
	self:RegisterEvent("CHAT_MSG_SKILL");
	self:RegisterEvent("TRADE_SKILL_SHOW");
	self:RegisterEvent("TRADE_SKILL_CLOSE");
	self:RegisterEvent("ITEM_PUSH");
end

function profbars_preclick_jc1(self, button, down)
	if GetItemCount(23425) then
		if not (GetItemCount(23425) < 5) then
			local x, y
			for i=1, GetNumStacks(23424) do
				local a, b = SearchPlayerBags(23424, i);
				local _, c = GetContainerItemInfo(a, b);
				if c >= 5 then
					x = a;
					y = b;
				end
			end
			if x then
				self:SetAttribute('type', 'spell');
				self:SetAttribute('spell', GetSpellInfo(31252));
				self:SetAttribute('target-bag', x);
				self:SetAttribute('target-slot', y);
			else
				local a, b = SearchPlayerBags(23425, 1);
				local _, c = GetContainerItemInfo(a, b);
				local d, e, f
				if c < 5 then
					d, e = SearchPlayerBags(23425, 2);
					_, f = GetContainerItemInfo(d, e);
					if (c+f) < 5 then
						SplitContainerItem(d, e, f);
					else
						SplitContainerItem(d, e, (5-c));
					end
					PickupContainerItem(a, b);
					print("Re-stacked items to allow prospecting, click again to start.");
				else
					self:SetAttribute('type', 'spell');
					self:SetAttribute('spell', GetSpellInfo(31252));
					self:SetAttribute('target-item', GetItemInfo(23425));
				end
			end
		else
			print("You don't have enough ore to prospect!");
		end
	else
		print("You don't have enough ore to prospect!");
	end
end

function profbars_preclick_jc2(self, button, down)
	if GetItemCount(36909) then
		if not (GetItemCount(36909) < 5) then
			local x, y
			for i=1, GetNumStacks(23424) do
				local a, b = SearchPlayerBags(23424, i);
				local _, c = GetContainerItemInfo(a, b);
				if c >= 5 then
					x = a;
					y = b;
				end
			end
			if x then
				self:SetAttribute('type', 'spell');
				self:SetAttribute('spell', GetSpellInfo(31252));
				self:SetAttribute('target-bag', x);
				self:SetAttribute('target-slot', y);
			else
				local a, b = SearchPlayerBags(36909, 1);
				local _, c = GetContainerItemInfo(a, b);
				local d, e, f
				if c < 5 then
					d, e = SearchPlayerBags(36909, 2);
					_, f = GetContainerItemInfo(d, e);
					if (c+f) < 5 then
						SplitContainerItem(d, e, f);
					else
						SplitContainerItem(d, e, (5-c));
					end
					PickupContainerItem(a, b);
					print("Re-stacked items to allow prospecting, click again to start.");
				else
					self:SetAttribute('type', 'spell');
					self:SetAttribute('spell', GetSpellInfo(31252));
					self:SetAttribute('target-item', GetItemInfo(36909));
				end
			end
		else
			print("You don't have enough ore to prospect!");
		end
	else
		print("You don't have enough ore to prospect!");
	end
end

function profbars_preclick_jc3(self, button, down)
	print(button);
	if GetItemCount(36912) then
		if not (GetItemCount(36912) < 5) then
			local x, y
			for i=1, GetNumStacks(23424) do
				local a, b = SearchPlayerBags(23424, i);
				local _, c = GetContainerItemInfo(a, b);
				if c >= 5 then
					x = a;
					y = b;
				end
			end
			if x then
				self:SetAttribute('type', 'spell');
				self:SetAttribute('spell', GetSpellInfo(31252));
				self:SetAttribute('target-bag', x);
				self:SetAttribute('target-slot', y);
			else
				local a, b = SearchPlayerBags(36912, 1);
				local _, c = GetContainerItemInfo(a, b);
				local d, e, f
				if c < 5 then
					d, e = SearchPlayerBags(36912, 2);
					_, f = GetContainerItemInfo(d, e);
					if (c+f) < 5 then
						SplitContainerItem(d, e, f);
					else
						SplitContainerItem(d, e, (5-c));
					end
					PickupContainerItem(a, b);
					print("Re-stacked items to allow prospecting, click again to start.");
				else
					self:SetAttribute('type', 'spell');
					self:SetAttribute('spell', GetSpellInfo(31252));
					self:SetAttribute('target-item', GetItemInfo(36912));
				end
			end
		else
			print("You don't have enough ore to prospect!");
		end
	else
		print("You don't have enough ore to prospect!");
	end
end

function profbars_preclick_jc4(self, button, down)
	if GetItemCount(23424) then
		if not (GetItemCount(23424) < 5) then
			local x, y
			for i=1, GetNumStacks(23424) do
				local a, b = SearchPlayerBags(23424, i);
				local _, c = GetContainerItemInfo(a, b);
				if c >= 5 then
					x = a;
					y = b;
				end
			end
			if x then
				self:SetAttribute('type', 'spell');
				self:SetAttribute('spell', GetSpellInfo(31252));
				self:SetAttribute('target-bag', x);
				self:SetAttribute('target-slot', y);
			else
				local a, b = SearchPlayerBags(23424, 1);
				local _, c = GetContainerItemInfo(a, b);
				local d, e, f
				if c < 5 then
					d, e = SearchPlayerBags(23424, 2);
					_, f = GetContainerItemInfo(d, e);
					if (c+f) < 5 then
						SplitContainerItem(d, e, f);
						PickupContainerItem(a, b);
						print("Re-stacked to allow prospecting");
					else
						SplitContainerItem(d, e, (5-c));
						PickupContainerItem(a, b);
						print("Re-stacked to allow prospecting");
					end
				else
					self:SetAttribute('type', 'spell');
					self:SetAttribute('spell', GetSpellInfo(31252));
					self:SetAttribute('target-bag', a);
					self:SetAttribute('target-slot', b);
				end
			end
		end
	end
end

function profbars_preclick_jc6(self, button, down)
	if GetItemCount(3858) then
		if not (GetItemCount(3858) < 5) then
			local x, y
			for i=1, GetNumStacks(3858) do
				local a, b = SearchPlayerBags(3858, i);
				local _, c = GetContainerItemInfo(a, b);
				if c >= 5 then
					x = a;
					y = b;
				end
			end
			if x then
				self:SetAttribute('type', 'spell');
				self:SetAttribute('spell', GetSpellInfo(3858));
				self:SetAttribute('target-bag', x);
				self:SetAttribute('target-slot', y);
			else
				local a, b = SearchPlayerBags(3858, 1);
				local _, c = GetContainerItemInfo(a, b);
				local d, e, f
				if c < 5 then
					d, e = SearchPlayerBags(3858, 2);
					_, f = GetContainerItemInfo(d, e);
					if (c+f) < 5 then
						SplitContainerItem(d, e, f);
					else
						SplitContainerItem(d, e, (5-c));
					end
					PickupContainerItem(a, b);
					print("Re-stacked items to allow prospecting, click again to start.");
				else
					self:SetAttribute('type', 'spell');
					self:SetAttribute('spell', GetSpellInfo(31252));
					self:SetAttribute('target-item', GetItemInfo(3858));
				end
			end
		else
			print("You don't have enough ore to prospect!");
		end
	else
		print("You don't have enough ore to prospect!");
	end
end

function profbars_preclick_jc7(self, button, down)
	if GetItemCount(2772) then
		if not (GetItemCount(2772) < 5) then
			local x, y
			for i=1, GetNumStacks(2772) do
				local a, b = SearchPlayerBags(2772, i);
				local _, c = GetContainerItemInfo(a, b);
				if c >= 5 then
					x = a;
					y = b;
				end
			end
			if x then
				self:SetAttribute('type', 'spell');
				self:SetAttribute('spell', GetSpellInfo(31252));
				self:SetAttribute('target-bag', x);
				self:SetAttribute('target-slot', y);
			else
				local a, b = SearchPlayerBags(2772, 1);
				local _, c = GetContainerItemInfo(a, b);
				local d, e, f
				if c < 5 then
					d, e = SearchPlayerBags(2772, 2);
					_, f = GetContainerItemInfo(d, e);
					if (c+f) < 5 then
						SplitContainerItem(d, e, f);
					else
						SplitContainerItem(d, e, (5-c));
					end
					PickupContainerItem(a, b);
					print("Re-stacked items to allow prospecting, click again to start.");
				else
					self:SetAttribute('type', 'spell');
					self:SetAttribute('spell', GetSpellInfo(31252));
					self:SetAttribute('target-item', GetItemInfo(2772));
				end
			end
		else
			print("You don't have enough ore to prospect!");
		end
	else
		print("You don't have enough ore to prospect!");
	end
end

function profbars_preclick_jc5(self, button, down)
	if GetItemCount(10620) then
		if not (GetItemCount(10620) < 5) then
			local x, y
			for i=1, GetNumStacks(10620) do
				local a, b = SearchPlayerBags(10620, i);
				local _, c = GetContainerItemInfo(a, b);
				if c >= 5 then
					x = a;
					y = b;
				end
			end
			if x then
				self:SetAttribute('type', 'spell');
				self:SetAttribute('spell', GetSpellInfo(31252));
				self:SetAttribute('target-bag', x);
				self:SetAttribute('target-slot', y);
			else
				local a, b = SearchPlayerBags(10620, 1);
				local _, c = GetContainerItemInfo(a, b);
				local d, e, f
				if c < 5 then
					d, e = SearchPlayerBags(10620, 2);
					_, f = GetContainerItemInfo(d, e);
					if (c+f) < 5 then
						SplitContainerItem(d, e, f);
					else
						SplitContainerItem(d, e, (5-c));
					end
					PickupContainerItem(a, b);
					print("Re-stacked items to allow prospecting, click again to start.");
				else
					self:SetAttribute('type', 'spell');
					self:SetAttribute('spell', GetSpellInfo(31252));
					self:SetAttribute('target-item', GetItemInfo(10620));
				end
			end
		else
			print("You don't have enough ore to prospect!");
		end
	else
		print("You don't have enough ore to prospect!");
	end
end

function profbars_preclick_jc8(self, button, down)
	if GetItemCount(2771) then
		if not (GetItemCount(2771) < 5) then
			local x, y
			for i=1, GetNumStacks(2771) do
				local a, b = SearchPlayerBags(2771, i);
				local _, c = GetContainerItemInfo(a, b);
				if c >= 5 then
					x = a;
					y = b;
				end
			end
			if x then
				self:SetAttribute('type', 'spell');
				self:SetAttribute('spell', GetSpellInfo(31252));
				self:SetAttribute('target-bag', x);
				self:SetAttribute('target-slot', y);
			else
				local a, b = SearchPlayerBags(2771, 1);
				local _, c = GetContainerItemInfo(a, b);
				local d, e, f
				if c < 5 then
					d, e = SearchPlayerBags(2771, 2);
					_, f = GetContainerItemInfo(d, e);
					if (c+f) < 5 then
						SplitContainerItem(d, e, f);
					else
						SplitContainerItem(d, e, (5-c));
					end
					PickupContainerItem(a, b);
					print("Re-stacked items to allow prospecting, click again to start.");
				else
					self:SetAttribute('type', 'spell');
					self:SetAttribute('spell', GetSpellInfo(31252));
					self:SetAttribute('target-item', GetItemInfo(2771));
				end
			end
		else
			print("You don't have enough ore to prospect!");
		end
	else
		print("You don't have enough ore to prospect!");
	end
end

function profbars_preclick_jc9(self, button, down)
	if GetItemCount(2770) then
		if not (GetItemCount(2770) < 5) then
			local x, y
			for i=1, GetNumStacks(2770) do
				local a, b = SearchPlayerBags(2770, i);
				local _, c = GetContainerItemInfo(a, b);
				if c >= 5 then
					x = a;
					y = b;
				end
			end
			if x then
				self:SetAttribute('type', 'spell');
				self:SetAttribute('spell', GetSpellInfo(31252));
				self:SetAttribute('target-bag', x);
				self:SetAttribute('target-slot', y);
			else
				local a, b = SearchPlayerBags(2770, 1);
				local _, c = GetContainerItemInfo(a, b);
				local d, e, f
				if c < 5 then
					d, e = SearchPlayerBags(2770, 2);
					_, f = GetContainerItemInfo(d, e);
					if (c+f) < 5 then
						SplitContainerItem(d, e, f);
					else
						SplitContainerItem(d, e, (5-c));
					end
					PickupContainerItem(a, b);
					print("Re-stacked items to allow prospecting, click again to start.");
				else
					self:SetAttribute('type', 'spell');
					self:SetAttribute('spell', GetSpellInfo(31252));
					self:SetAttribute('target-item', GetItemInfo(2770));
				end
			end
		else
			print("You don't have enough ore to prospect!");
		end
	else
		print("You don't have enough ore to prospect!");
	end
end

function profbars_preclick_insc2(self, button, down)
	if GetItemCount(36903) or GetItemCount(37921) or GetItemCount(39970) or GetItemCount(36901) or GetItemCount(36906) or GetItemCount(36905) or GetItemCount(36907) or GetItemCount(36904) then
		local item
		if GetItemCount(36903)>=5 then
			item=36903;
		elseif GetItemCount(37921)>=5 then
			item=37921;
		elseif GetItemCount(39970)>=5 then
			item=39970;
		elseif GetItemCount(36901)>=5 then
			item=36901;
		elseif GetItemCount(36906)>=5 then
			item=36906;
		elseif GetItemCount(36905)>=5 then
			item=36905;
		elseif GetItemCount(36907)>=5 then
			item=36907;
		elseif GetItemCount(36904)>=5 then
			item=36904;
		end
		if item then
			local a, b = SearchPlayerBags(item, 1);
			local _, c = GetContainerItemInfo(a, b);
			local d, e, f
			if c < 5 then
				d, e = SearchPlayerBags(item, 2);
				_, f = GetContainerItemInfo(d, e);
				if (c+f) < 5 then
					SplitContainerItem(d, e, f);
				else
					SplitContainerItem(d, e, (5-c));
				end
				PickupContainerItem(a, b);
				print("Re-stacked items to allow milling, click again to start.");
			else
				self:SetAttribute('type', 'spell');
				self:SetAttribute('spell', GetSpellInfo(51005));
				self:SetAttribute('target-item', GetItemInfo(item));
			end
		else
			print("You don't have enough herbs to mill!");
		end
	else
		print("You don't have any herbs to mill!");
	end
end

function profbars_preclick_insc1(self, button, down)
	if GetItemCount(22790) or GetItemCount(22786) or GetItemCount(22785) or GetItemCount(22793) or GetItemCount(22791) or GetItemCount(22792) or GetItemCount(22787) or GetItemCount(22789) then
		local item
		if GetItemCount(22790)>=5 then
			item=22790;
		elseif GetItemCount(22786)>=5 then
			item=22786;
		elseif GetItemCount(22785)>=5 then
			item=22785;
		elseif GetItemCount(22793)>=5 then
			item=22793;
		elseif GetItemCount(22791)>=5 then
			item=22791;
		elseif GetItemCount(22792)>=5 then
			item=22792;
		elseif GetItemCount(22787)>=5 then
			item=22787;
		elseif GetItemCount(22789)>=5 then
			item=22789;
		end
		if item then
			local a, b = SearchPlayerBags(item, 1);
			local _, c = GetContainerItemInfo(a, b);
			local d, e, f
			if c < 5 then
				d, e = SearchPlayerBags(item, 2);
				_, f = GetContainerItemInfo(d, e);
				if (c+f) < 5 then
					SplitContainerItem(d, e, f);
				else
					SplitContainerItem(d, e, (5-c));
				end
				PickupContainerItem(a, b);
				print("Re-stacked items to allow milling, click again to start.");
			else
				self:SetAttribute('type', 'spell');
				self:SetAttribute('spell', GetSpellInfo(51005));
				self:SetAttribute('target-item', GetItemInfo(item));
			end
		else
			print("You don't have enough herbs to mill!");
		end
	else
		print("You don't have any herbs to mill!");
	end
end

function profbars_preclick_insc4(self, button, down)
	if GetItemCount(13463) or GetItemCount(13464) or GetItemCount(13467) or GetItemCount(13465) or GetItemCount(13466) then
		local item
		if GetItemCount(13463)>=5 then
			item=13463;
		elseif GetItemCount(13464)>=5 then
			item=13464;
		elseif GetItemCount(13467)>=5 then
			item=13467;
		elseif GetItemCount(13465)>=5 then
			item=13465;
		elseif GetItemCount(13466)>=5 then
			item=13466;
		end
		if item then
			local a, b = SearchPlayerBags(item, 1);
			local _, c = GetContainerItemInfo(a, b);
			local d, e, f
			if c < 5 then
				d, e = SearchPlayerBags(item, 2);
				_, f = GetContainerItemInfo(d, e);
				if (c+f) < 5 then
					SplitContainerItem(d, e, f);
				else
					SplitContainerItem(d, e, (5-c));
				end
				PickupContainerItem(a, b);
				print("Re-stacked items to allow milling, click again to start.");
			else
				self:SetAttribute('type', 'spell');
				self:SetAttribute('spell', GetSpellInfo(51005));
				self:SetAttribute('target-item', GetItemInfo(item));
			end
		else
			print("You don't have enough herbs to mill!");
		end
	else
		print("You don't have any herbs to mill!");
	end
end

function profbars_preclick_insc5(self, button, down)
	if GetItemCount(8836) or GetItemCount(8839) or GetItemCount(4625) or GetItemCount(8845) or GetItemCount(8846) or GetItemCount(8831) or GetItemCount(8838) then
		local item
		if GetItemCount(8836)>=5 then
			item=8836;
		elseif GetItemCount(8839)>=5 then
			item=8839;
		elseif GetItemCount(4625)>=5 then
			item=4625;
		elseif GetItemCount(8845)>=5 then
			item=8845;
		elseif GetItemCount(8846)>=5 then
			item=8846;
		elseif GetItemCount(8831)>=5 then
			item=8831;
		elseif GetItemCount(8838)>=5 then
			item=8838;
		end
		if item then
			local a, b = SearchPlayerBags(item, 1);
			local _, c = GetContainerItemInfo(a, b);
			local d, e, f
			if c < 5 then
				d, e = SearchPlayerBags(item, 2);
				_, f = GetContainerItemInfo(d, e);
				if (c+f) < 5 then
					SplitContainerItem(d, e, f);
				else
					SplitContainerItem(d, e, (5-c));
				end
				PickupContainerItem(a, b);
				print("Re-stacked items to allow milling, click again to start.");
			else
				self:SetAttribute('type', 'spell');
				self:SetAttribute('spell', GetSpellInfo(51005));
				self:SetAttribute('target-item', GetItemInfo(item));
			end
		else
			print("You don't have enough herbs to mill!");
		end
	else
		print("You don't have any herbs to mill!");
	end
end

function profbars_preclick_insc6(self, button, down)
	if GetItemCount(3818) or GetItemCount(3821) or GetItemCount(3358) or GetItemCount(3819) then
		local item
		if GetItemCount(3818)>=5 then
			item=3818;
		elseif GetItemCount(3821)>=5 then
			item=3821;
		elseif GetItemCount(3358)>=5 then
			item=3358;
		elseif GetItemCount(3819)>=5 then
			item=3819;
		end
		if item then
			local a, b = SearchPlayerBags(item, 1);
			local _, c = GetContainerItemInfo(a, b);
			local d, e, f
			if c < 5 then
				d, e = SearchPlayerBags(item, 2);
				_, f = GetContainerItemInfo(d, e);
				if (c+f) < 5 then
					SplitContainerItem(d, e, f);
				else
					SplitContainerItem(d, e, (5-c));
				end
				PickupContainerItem(a, b);
				print("Re-stacked items to allow milling, click again to start.");
			else
				self:SetAttribute('type', 'spell');
				self:SetAttribute('spell', GetSpellInfo(51005));
				self:SetAttribute('target-item', GetItemInfo(item));
			end
		else
			print("You don't have enough herbs to mill!");
		end
	else
		print("You don't have any herbs to mill!");
	end
end

function profbars_preclick_insc7(self, button, down)
	if GetItemCount(3369) or GetItemCount(3356) or GetItemCount(3357) or GetItemCount(3355) then
		local item
		if GetItemCount(3369)>=5 then
			item=3369;
		elseif GetItemCount(3356)>=5 then
			item=3356;
		elseif GetItemCount(3357)>=5 then
			item=3357;
		elseif GetItemCount(3355)>=5 then
			item=3355;
		end
		if item then
			local a, b = SearchPlayerBags(item, 1);
			local _, c = GetContainerItemInfo(a, b);
			local d, e, f
			if c < 5 then
				d, e = SearchPlayerBags(item, 2);
				_, f = GetContainerItemInfo(d, e);
				if (c+f) < 5 then
					SplitContainerItem(d, e, f);
				else
					SplitContainerItem(d, e, (5-c));
				end
				PickupContainerItem(a, b);
				print("Re-stacked items to allow milling, click again to start.");
			else
				self:SetAttribute('type', 'spell');
				self:SetAttribute('spell', GetSpellInfo(51005));
				self:SetAttribute('target-item', GetItemInfo(item));
			end
		else
			print("You don't have enough herbs to mill!");
		end
	else
		print("You don't have any herbs to mill!");
	end
end

function profbars_preclick_insc8(self, button, down)
	if GetItemCount(2450) or GetItemCount(2453) or GetItemCount(785) or GetItemCount(3820) or GetItemCount(2452) then
		local item
		if GetItemCount(785)>=5 then
			item=785;
		elseif GetItemCount(2453)>=5 then
			item=2453;
		elseif GetItemCount(2450)>=5 then
			item=2450;
		elseif GetItemCount(3820)>=5 then
			item=3820;
		elseif GetItemCount(2452)>=5 then
			item=2452;
		end
		if item then
			local a, b = SearchPlayerBags(item, 1);
			local _, c = GetContainerItemInfo(a, b);
			local d, e, f
			if c < 5 then
				d, e = SearchPlayerBags(item, 2);
				_, f = GetContainerItemInfo(d, e);
				if (c+f) < 5 then
					SplitContainerItem(d, e, f);
				else
					SplitContainerItem(d, e, (5-c));
				end
				PickupContainerItem(a, b);
				print("Re-stacked items to allow milling, click again to start.");
			else
				self:SetAttribute('type', 'spell');
				self:SetAttribute('spell', GetSpellInfo(51005));
				self:SetAttribute('target-item', GetItemInfo(item));
			end
		else
			print("You don't have enough herbs to mill!");
		end
	else
		print("You don't have any herbs to mill!");
	end
end

function profbars_preclick_insc9(self, button, down)
	if GetItemCount(2449) or GetItemCount(2447) or GetItemCount(765) then
		local item
		if GetItemCount(2449)>=5 then
			item=2449;
		elseif GetItemCount(2447)>=5 then
			item=2447;
		elseif GetItemCount(765)>=5 then
			item=765;
		end
		if item then
			local a, b = SearchPlayerBags(item, 1);
			local _, c = GetContainerItemInfo(a, b);
			local d, e, f
			if c < 5 then
				d, e = SearchPlayerBags(item, 2);
				_, f = GetContainerItemInfo(d, e);
				if (c+f) < 5 then
					SplitContainerItem(d, e, f);
				else
					SplitContainerItem(d, e, (5-c));
				end
				PickupContainerItem(a, b);
				print("Re-stacked items to allow prospecting, click again to start.");
			else
				self:SetAttribute('type', 'spell');
				self:SetAttribute('spell', GetSpellInfo(51005));
				self:SetAttribute('target-item', GetItemInfo(item));
			end
		else
			print("You don't have enough herbs to mill!");
		end
	else
		print("You don't have any herbs to mill!");
	end
end

function profbars_startdragging_jc()
	profbars_jewelcrafting:StartMoving()
end

function profbars_stopdragging_jc()
	profbars_offsets_x["jc"] = profbars_jewelcrafting:GetLeft();
	profbars_offsets_y["jc"] = profbars_jewelcrafting:GetBottom();
	profbars_jewelcrafting:StopMovingOrSizing();
end

function profbars_startdragging_insc()
	profbars_inscription:StartMoving()
end

function profbars_stopdragging_insc()
	profbars_offsets_x["insc"] = profbars_inscription:GetLeft();
	profbars_offsets_y["insc"] = profbars_inscription:GetBottom();
	profbars_inscription:StopMovingOrSizing();
end

--This function is untested
function ProfessionBars:CHAT_MSG_SKILL(msg)
	ProfessionBars:ITEM_PUSH();
end

function ProfessionBars:TRADE_SKILL_SHOW()
	if profbars_data.mode == 2 then
		local a = GetTradeSkillLine();
		if string.match(a, "%S+") == GetSpellInfo(25229) then
			if IsAddOnLoaded("AdvancedTradeSkillWindow") then
				profbars_jewelcrafting:ClearAllPoints();
				profbars_jewelcrafting:SetPoint("TOP", ATSWFrame, "BOTTOM", 0, 10);
			else
				profbars_jewelcrafting:ClearAllPoints();
				profbars_jewelcrafting:SetPoint("TOP", TradeSkillFrame, "BOTTOMLEFT", 180, 75);
			end
			if PlayerHasSpell(45357) then
				profbars_inscription:Hide()
			end
			profbars_jewelcrafting:Show();
		elseif string.match(a, "%S+") == GetSpellInfo(45357) then
			if IsAddOnLoaded("AdvancedTradeSkillWindow") then
				profbars_inscription:ClearAllPoints();
				profbars_inscription:SetPoint("TOP", ATSWFrame, "BOTTOM", 0, 10);
			else
				profbars_inscription:ClearAllPoints();
				profbars_inscription:SetPoint("TOP", TradeSkillFrame, "BOTTOMLEFT", 180, 75);
			end
			if PlayerHasSpell(25229) then
				profbars_jewelcrafting:Hide();
			end
			profbars_inscription:Show();
		else
			if PlayerHasSpell(25229) then
				profbars_jewelcrafting:Hide();
			end
			if PlayerHasSpell(45357) then
				profbars_inscription:Hide();
			end
		end
		ProfessionBars:ITEM_PUSH();
	end
end

function ProfessionBars:TRADE_SKILL_CLOSE()
	if profbars_data.mode == 2 then
		if PlayerHasSpell(25229) then
			profbars_jewelcrafting:Hide();
		end
		if PlayerHasSpell(45357) then
			profbars_inscription:Hide();
		end
	end
end

function ProfessionBars:ITEM_PUSH()
	if PlayerHasSpell(25229) then
		local c
		for i=1, GetNumSkillLines() do
			local name,_,_, level = GetSkillLineInfo(i);
			if name==GetSpellInfo(25229) then
				c = level;
			end
		end
		local a = {};
		if GetItemCount(2770) >= 5 and c >= 20 then
			local b = #a+1;
			a[b] = profbars_jcbutton9;
		end
		if GetItemCount(2771) >= 5 and c >= 50 then
			local b = #a+1;
			a[b] = profbars_jcbutton8;
		end
		if GetItemCount(2772) >= 5 and c >= 125 then
			local b = #a+1;
			a[b] = profbars_jcbutton7;
		end
		if GetItemCount(3858) >= 5 and c >= 175 then
			local b = #a+1;
			a[b] = profbars_jcbutton6;
		end
		if GetItemCount(10620) >= 5 and c >= 250 then
			local b = #a+1;
			a[b] = profbars_jcbutton5;
		end
		if GetItemCount(23424) >= 5 and c >= 275 then
			local b = #a+1;
			a[b] = profbars_jcbutton4;
		end
		if GetItemCount(23425) >= 5 and c >= 325 then
			local b = #a+1;
			a[b] = profbars_jcbutton1;
		end
		if GetItemCount(36909) >= 5 and c >= 350 then
			local b = #a+1;
			a[b] = profbars_jcbutton2;
		end
		if GetItemCount(36912) >= 5 and c >= 400 then
			local b = #a+1;
			a[b] = profbars_jcbutton3;
		end
		if profbars_data.mode == 1 then
			profbars_jewelcrafting:SetWidth(#a*35+17.5);
		else
			profbars_jewelcrafting:SetWidth(#a*35);
		end
		profbars_jcbutton1:Hide();
		profbars_jcbutton2:Hide();
		profbars_jcbutton3:Hide();
		profbars_jcbutton4:Hide();
		profbars_jcbutton5:Hide();
		profbars_jcbutton6:Hide();
		profbars_jcbutton7:Hide();
		profbars_jcbutton8:Hide();
		profbars_jcbutton9:Hide();
		profbars_jcmove:Hide();
		for i=1, #a do
			a[i]:ClearAllPoints()
			a[i]:SetPoint("TOPLEFT", profbars_jewelcrafting, "TOPLEFT", (i-1)*35, 0);
			a[i]:Show();
		end
		if profbars_data.mode == 1 and #a > 0 then
			profbars_jcmove:Show();
		end
	end
	if PlayerHasSpell(45357) then
		local c
		for i=1, GetNumSkillLines() do
			local name,_,_, level = GetSkillLineInfo(i);
			if name==GetSpellInfo(45357) then
				c = level;
			end
		end
		local a = {};
		if ((GetItemCount(2449) >= 5) or (GetItemCount(2447)>=5) or (GetItemCount(765)>=5)) and c >= 1 then
			local b = #a+1;
			a[b] = profbars_inscbutton9;
		end
		if (((GetItemCount(2450)>=5) or (GetItemCount(2453)>=5) or (GetItemCount(3820)>=5) or (GetItemCount(2452)>=5)) and c >= 25) or (GetItemCount(785) >= 5 and c >= 1) then
			local b = #a+1;
			a[b] = profbars_inscbutton8;
		end
		if ((GetItemCount(3369) >= 5) or (GetItemCount(3356) >= 5) or (GetItemCount(3357) >= 5) or (GetItemCount(3355)>=5)) and c >= 75 then
			local b = #a+1;
			a[b] = profbars_inscbutton7;
		end
		if ((GetItemCount(3818) >= 5) or (GetItemCount(3821) >= 5) or (GetItemCount(3358) >= 5) or (GetItemCount(3819)>=5)) and c >= 125 then
			local b = #a+1;
			a[b] = profbars_inscbutton6;
		end
		if ((GetItemCount(8836) >= 5) or (GetItemCount(8839) >= 5) or (GetItemCount(4625)>=5) or (GetItemCount(8845)>=5) or (GetItemCount(8846)>=5) or (GetItemCount(8831)>=5) or (GetItemCount(8838)>=5)) and c >= 175 then
			local b = #a+1;
			a[b] = profbars_inscbutton5;
		end
		if ((GetItemCount(13463) >= 5) or (GetItemCount(13464) >= 5) or (GetItemCount(13467) >= 5) or (GetItemCount(13465) >= 5) or (GetItemCount(13466)>=5)) and c >= 225 then
			local b = #a+1;
			a[b] = profbars_inscbutton4;
		end
		if ((GetItemCount(22790)>=5) or (GetItemCount(22786)>=5) or (GetItemCount(22785) >= 5) or (GetItemCount(22793)>=5) or (GetItemCount(22791) >=5) or (GetItemCount(22792)>=5) or (GetItemCount(22787)>=5) or (GetItemCount(22789)>=5)) and c >= 275 then
			local b = #a+1;
			a[b] = profbars_inscbutton1;
		end
		if ((GetItemCount(36903)>=5) or (GetItemCount(37921)>=5) or (GetItemCount(39970) >= 5) or (GetItemCount(36901)>=5) or (GetItemCount(36906)>=5) or (GetItemCount(36905)>=5) or (GetItemCount(36907)>=5) or (GetItemCount(36904)>=5)) and c >= 325 then
			local b = #a+1;
			a[b] = profbars_inscbutton2;
		end
		if profbars_data.mode == 1 then
			profbars_inscription:SetWidth(#a*35+17.5);
		else
			profbars_inscription:SetWidth(#a*35);
		end
		profbars_inscbutton1:Hide();
		profbars_inscbutton2:Hide();
		profbars_inscbutton4:Hide();
		profbars_inscbutton5:Hide();
		profbars_inscbutton6:Hide();
		profbars_inscbutton7:Hide();
		profbars_inscbutton8:Hide();
		profbars_inscbutton9:Hide();
		for i=1, #a do
			a[i]:ClearAllPoints();
			a[i]:SetPoint("TOPLEFT", profbars_inscription, "TOPLEFT", (i-1)*35, 0);
			a[i]:Show();
		end
		if profbars_data.mode == 1 and #a > 0 then
			profbars_inscmove:Show();
		end
	end
end

function ProfessionBars:PLAYER_ENTERING_WORLD()
	if PlayerHasSpell(25229) then
		local jc_bar = CreateFrame("Frame", "profbars_jewelcrafting", UIParent);
		jc_bar:SetHeight(35);
		jc_bar:SetMovable(true);	
		--Parent it to UIParent
		if not profbars_offsets_x then
			profbars_offsets_x = {};
			profbars_offsets_y = {};
		end
		if not profbars_offsets_x["jc"] then
			profbars_offsets_x["jc"] = 250;
			profbars_offsets_y["jc"] = 250;
		end
		jc_bar:SetPoint("BOTTOMLEFT", UIParent, profbars_offsets_x["jc"], profbars_offsets_y["jc"]);
		--Set this according to skill later
		jc_bar:SetWidth(332.5);
		--Here starts testing definition of button 1
		local jc_button1 = CreateFrame("Button", "profbars_jcbutton1", profbars_jewelcrafting, "SecureActionButtonTemplate");
		jc_button1:SetHeight(35);
		jc_button1:SetWidth(35);
		jc_button1:SetScript("PreClick", profbars_preclick_jc1);
		jc_button1:RegisterForClicks("AnyUp");
		jc_button1:SetPoint("TOPLEFT", profbars_jewelcrafting, "TOPLEFT", 210, 0);
		jc_button1:SetNormalTexture("Interface\\Icons\\INV_Ore_Adamantium");
		jc_button1:SetHighlightTexture("Interface\\Icons\\INV_Ore_Adamantium", 1.5);
		jc_button1:SetScript("OnEnter", OnEnter);
		jc_button1:SetScript("OnLeave", OnLeave);
		--Here ends testing definition of button 1
		--button 2 defined
		local jc_button2 = CreateFrame("Button", "profbars_jcbutton2", profbars_jewelcrafting, "SecureActionButtonTemplate");
		jc_button2:SetHeight(35);
		jc_button2:SetWidth(35);
		jc_button2:SetScript("PreClick", profbars_preclick_jc2);
		jc_button2:RegisterForClicks("AnyUp");
		jc_button2:SetPoint("TOPLEFT", profbars_jewelcrafting, "TOPLEFT", 245, 0);
		jc_button2:SetNormalTexture("Interface\\Icons\\INV_Ore_Cobalt");
		jc_button2:SetHighlightTexture("Interface\\Icons\\INV_Ore_Cobalt", 1.5);
		jc_button2:SetScript("OnEnter", OnEnter);
		jc_button2:SetScript("OnLeave", OnLeave);
		--button 2 done
		local jc_button3 = CreateFrame("Button", "profbars_jcbutton3", profbars_jewelcrafting, "SecureActionButtonTemplate");
		jc_button3:SetHeight(35);
		jc_button3:SetWidth(35);
		jc_button3:SetScript("PreClick", profbars_preclick_jc3);
		jc_button3:RegisterForClicks("AnyUp");
		jc_button3:SetPoint("TOPLEFT", profbars_jewelcrafting, "TOPLEFT", 280, 0);
		jc_button3:SetNormalTexture("Interface\\Icons\\INV_Ore_Saronite_01");
		jc_button3:SetHighlightTexture("Interface\\Icons\\INV_Ore_Saronite_01", 1.5);
		jc_button3:SetScript("OnEnter", OnEnter);
		jc_button3:SetScript("OnLeave", OnLeave);
		local jc_button4 = CreateFrame("Button", "profbars_jcbutton4", profbars_jewelcrafting, "SecureActionButtonTemplate");
		jc_button4:SetHeight(35);
		jc_button4:SetWidth(35);
		jc_button4:SetScript("PreClick", profbars_preclick_jc4);
		jc_button4:RegisterForClicks("AnyUp");
		jc_button4:SetPoint("TOPLEFT", profbars_jewelcrafting, "TOPLEFT", 175, 0);
		jc_button4:SetNormalTexture("Interface\\Icons\\INV_Ore_FelIron");
		jc_button4:SetHighlightTexture("Interface\\Icons\\INV_Ore_FelIron", 1.5);
		jc_button4:SetScript("OnEnter", OnEnter);
		jc_button4:SetScript("OnLeave", OnLeave);
		local jc_button5 = CreateFrame("Button", "profbars_jcbutton5", profbars_jewelcrafting, "SecureActionButtonTemplate");
		jc_button5:SetHeight(35);
		jc_button5:SetWidth(35);
		jc_button5:SetScript("PreClick", profbars_preclick_jc5);
		jc_button5:RegisterForClicks("AnyUp");
		jc_button5:SetPoint("TOPLEFT", profbars_jewelcrafting, "TOPLEFT", 140, 0);
		jc_button5:SetNormalTexture("Interface\\Icons\\INV_Ore_Thorium_02");
		jc_button5:SetHighlightTexture("Interface\\Icons\\INV_Ore_Thorium_02", 1.5);
		jc_button5:SetScript("OnEnter", OnEnter);
		jc_button5:SetScript("OnLeave", OnLeave);
		local jc_button6 = CreateFrame("Button", "profbars_jcbutton6", profbars_jewelcrafting, "SecureActionButtonTemplate");
		jc_button6:SetHeight(35);
		jc_button6:SetWidth(35);
		jc_button6:SetScript("PreClick", profbars_preclick_jc6);
		jc_button6:RegisterForClicks("AnyUp");
		jc_button6:SetPoint("TOPLEFT", profbars_jewelcrafting, "TOPLEFT", 105, 0);
		jc_button6:SetNormalTexture("Interface\\Icons\\INV_Ore_Mithril_02");
		jc_button6:SetHighlightTexture("Interface\\Icons\\INV_Ore_Mithril_02", 1.5);
		jc_button6:SetScript("OnEnter", OnEnter);
		jc_button6:SetScript("OnLeave", OnLeave);
		local jc_button7 = CreateFrame("Button", "profbars_jcbutton7", profbars_jewelcrafting, "SecureActionButtonTemplate");
		jc_button7:SetHeight(35);
		jc_button7:SetWidth(35);
		jc_button7:SetScript("PreClick", profbars_preclick_jc7);
		jc_button7:RegisterForClicks("AnyUp");
		jc_button7:SetPoint("TOPLEFT", profbars_jewelcrafting, "TOPLEFT", 70, 0);
		jc_button7:SetNormalTexture("Interface\\Icons\\INV_Ore_Iron_01");
		jc_button7:SetHighlightTexture("Interface\\Icons\\INV_Ore_Iron_01", 1.5);
		jc_button7:SetScript("OnEnter", OnEnter);
		jc_button7:SetScript("OnLeave", OnLeave);
		local jc_button8 = CreateFrame("Button", "profbars_jcbutton8", profbars_jewelcrafting, "SecureActionButtonTemplate");
		jc_button8:SetHeight(35);
		jc_button8:SetWidth(35);
		jc_button8:SetScript("PreClick", profbars_preclick_jc8);
		jc_button8:RegisterForClicks("AnyUp");
		jc_button8:SetPoint("TOPLEFT", profbars_jewelcrafting, "TOPLEFT", 35, 0);
		jc_button8:SetNormalTexture("Interface\\Icons\\INV_Ore_Tin_01");
		jc_button8:SetHighlightTexture("Interface\\Icons\\INV_Ore_Tin_01", 1.5);
		jc_button8:SetScript("OnEnter", OnEnter);
		jc_button8:SetScript("OnLeave", OnLeave);
		local jc_button9 = CreateFrame("Button", "profbars_jcbutton9", profbars_jewelcrafting, "SecureActionButtonTemplate");
		jc_button9:SetHeight(35);
		jc_button9:SetWidth(35);
		jc_button9:SetScript("PreClick", profbars_preclick_jc9);
		jc_button9:RegisterForClicks("AnyUp");
		jc_button9:SetPoint("TOPLEFT", profbars_jewelcrafting, "TOPLEFT");
		jc_button9:SetNormalTexture("Interface\\Icons\\INV_Ore_Copper_01");
		jc_button9:SetHighlightTexture("Interface\\Icons\\INV_Ore_Copper_01", 1.5);
		jc_button9:SetScript("OnEnter", OnEnter);
		jc_button9:SetScript("OnLeave", OnLeave);
		local jc_movebutton = CreateFrame("Button", "profbars_jcmove", profbars_jewelcrafting);
		jc_movebutton:SetHeight(17.5);
		jc_movebutton:SetWidth(17.5);
		jc_movebutton:SetScript("OnMouseDown", profbars_startdragging_jc);
		jc_movebutton:SetScript("OnMouseUp", profbars_stopdragging_jc);
		jc_movebutton:SetPoint("TOPRIGHT", profbars_jewelcrafting, "TOPRIGHT");
		jc_movebutton:SetHighlightTexture("Interface\\Icons\\Spell_Arcane_PortalStormWind", 0.8);
		if not PlayerHasSpell(45357) then
			ProfessionBars:ScheduleTimer("ITEM_PUSH", 1);
		end
		if profbars_data.mode == 2 then
			if IsAddOnLoaded("AdvancedTradeSkillWindow") then
				jc_bar:ClearAllPoints();
				jc_bar:SetPoint("TOP", ATSWFrame, "BOTTOM", 0, 10);
			else
				jc_bar:ClearAllPoints();
				jc_bar:SetPoint("TOP", TradeSkillFrame, "BOTTOMLEFT", 180, 75);
			end
			jc_movebutton:Hide();
			jc_bar:Hide();
		end
	end
	if PlayerHasSpell(2259) then
		--Alchemy
	end
	if PlayerHasSpell(2018) then
		--Blacksmithing
	end
	if PlayerHasSpell(7411) then
		--Enchanting
	end
	if PlayerHasSpell(4036) then	
		--Engineering
	end
	if PlayerHasSpell(2366) then
		--Herbalism
	end
	if PlayerHasSpell(45357) then
		local insc_bar = CreateFrame("Frame", "profbars_inscription", UIParent);
		insc_bar:SetHeight(35);
		insc_bar:SetMovable(true);	
		--Parent it to UIParent
		if not profbars_offsets_x then
			profbars_offsets_x = {};
			profbars_offsets_y = {};
		end
		if not profbars_offsets_x["insc"] then
			profbars_offsets_x["insc"] = 250;
			profbars_offsets_y["insc"] = 250;
		end
		insc_bar:SetPoint("BOTTOMLEFT", UIParent, profbars_offsets_x["insc"], profbars_offsets_y["insc"]);
		--Set this according to skill later
		insc_bar:SetWidth(297.5);
		--Here starts testing definition of button 1
		local insc_button1 = CreateFrame("Button", "profbars_inscbutton1", profbars_inscription, "SecureActionButtonTemplate");
		insc_button1:SetHeight(35);
		insc_button1:SetWidth(35);
		insc_button1:SetScript("PreClick", profbars_preclick_insc1);
		insc_button1:RegisterForClicks("AnyUp");
		insc_button1:SetPoint("TOPLEFT", profbars_inscription, "TOPLEFT", 210, 0);
		insc_button1:SetNormalTexture("Interface\\Icons\\inv_inscription_pigment_nether");
		insc_button1:SetHighlightTexture("Interface\\Icons\\inv_inscription_pigment_nether", 1.5);
		insc_button1:SetScript("OnEnter", OnEnter);
		insc_button1:SetScript("OnLeave", OnLeave);
		--Here ends testing definition of button 1
		--button 2 defined
		local insc_button2 = CreateFrame("Button", "profbars_inscbutton2", profbars_inscription, "SecureActionButtonTemplate");
		insc_button2:SetHeight(35);
		insc_button2:SetWidth(35);
		insc_button2:SetScript("PreClick", profbars_preclick_insc2);
		insc_button2:RegisterForClicks("AnyUp");
		insc_button2:SetPoint("TOPLEFT", profbars_inscription, "TOPLEFT", 245, 0);
		insc_button2:SetNormalTexture("Interface\\Icons\\inv_inscription_pigment_azure");
		insc_button2:SetHighlightTexture("Interface\\Icons\\inv_inscription_pigment_azure", 1.5);
		insc_button2:SetScript("OnEnter", OnEnter);
		insc_button2:SetScript("OnLeave", OnLeave);
		--button 2 done
		-- local insc_button3 = CreateFrame("Button", "profbars_inscbutton3", profbars_inscription, "SecureActionButtonTemplate");
		-- insc_button3:SetHeight(35);
		-- insc_button3:SetWidth(35);
		-- insc_button3:SetScript("PreClick", profbars_preclick_insc3);
		-- insc_button3:RegisterForClicks("AnyUp");
		-- insc_button3:SetPoint("TOPLEFT", profbars_inscription, "TOPLEFT", 280, 0);
		-- insc_button3:SetNormalTexture("Interface\\Icons\\INV_Ore_Saronite_01");
		-- insc_button3:SetHighlightTexture("Interface\\Icons\\INV_Ore_Saronite_01", 1.5);
		local insc_button4 = CreateFrame("Button", "profbars_inscbutton4", profbars_inscription, "SecureActionButtonTemplate");
		insc_button4:SetHeight(35);
		insc_button4:SetWidth(35);
		insc_button4:SetScript("PreClick", profbars_preclick_insc4);
		insc_button4:RegisterForClicks("AnyUp");
		insc_button4:SetPoint("TOPLEFT", profbars_inscription, "TOPLEFT", 175, 0);
		insc_button4:SetNormalTexture("Interface\\Icons\\inv_inscription_pigment_silvery");
		insc_button4:SetHighlightTexture("Interface\\Icons\\inv_inscription_pigment_silvery", 1.5);
		insc_button4:SetScript("OnEnter", OnEnter);
		insc_button4:SetScript("OnLeave", OnLeave);
		local insc_button5 = CreateFrame("Button", "profbars_inscbutton5", profbars_inscription, "SecureActionButtonTemplate");
		insc_button5:SetHeight(35);
		insc_button5:SetWidth(35);
		insc_button5:SetScript("PreClick", profbars_preclick_insc5);
		insc_button5:RegisterForClicks("AnyUp");
		insc_button5:SetPoint("TOPLEFT", profbars_inscription, "TOPLEFT", 140, 0);
		insc_button5:SetNormalTexture("Interface\\Icons\\inv_inscription_pigment_violet");
		insc_button5:SetHighlightTexture("Interface\\Icons\\inv_inscription_pigment_violet", 1.5);
		insc_button5:SetScript("OnEnter", OnEnter);
		insc_button5:SetScript("OnLeave", OnLeave);
		local insc_button6 = CreateFrame("Button", "profbars_inscbutton6", profbars_inscription, "SecureActionButtonTemplate");
		insc_button6:SetHeight(35);
		insc_button6:SetWidth(35);
		insc_button6:SetScript("PreClick", profbars_preclick_insc6);
		insc_button6:RegisterForClicks("AnyUp");
		insc_button6:SetPoint("TOPLEFT", profbars_inscription, "TOPLEFT", 105, 0);
		insc_button6:SetNormalTexture("Interface\\Icons\\inv_inscription_pigment_emerald");
		insc_button6:SetHighlightTexture("Interface\\Icons\\inv_inscription_pigment_emerald", 1.5);
		insc_button6:SetScript("OnEnter", OnEnter);
		insc_button6:SetScript("OnLeave", OnLeave);
		local insc_button7 = CreateFrame("Button", "profbars_inscbutton7", profbars_inscription, "SecureActionButtonTemplate");
		insc_button7:SetHeight(35);
		insc_button7:SetWidth(35);
		insc_button7:SetScript("PreClick", profbars_preclick_insc7);
		insc_button7:RegisterForClicks("AnyUp");
		insc_button7:SetPoint("TOPLEFT", profbars_inscription, "TOPLEFT", 70, 0);
		insc_button7:SetNormalTexture("Interface\\Icons\\inv_inscription_pigment_golden");
		insc_button7:SetHighlightTexture("Interface\\Icons\\inv_inscription_pigment_golden", 1.5);
		insc_button7:SetScript("OnEnter", OnEnter);
		insc_button7:SetScript("OnLeave", OnLeave);
		local insc_button8 = CreateFrame("Button", "profbars_inscbutton8", profbars_inscription, "SecureActionButtonTemplate");
		insc_button8:SetHeight(35);
		insc_button8:SetWidth(35);
		insc_button8:SetScript("PreClick", profbars_preclick_insc8);
		insc_button8:RegisterForClicks("AnyUp");
		insc_button8:SetPoint("TOPLEFT", profbars_inscription, "TOPLEFT", 35, 0);
		insc_button8:SetNormalTexture("Interface\\Icons\\inv_inscription_pigment_grey");
		insc_button8:SetHighlightTexture("Interface\\Icons\\inv_inscription_pigment_grey", 1.5);
		insc_button8:SetScript("OnEnter", OnEnter);
		insc_button8:SetScript("OnLeave", OnLeave);
		local insc_button9 = CreateFrame("Button", "profbars_inscbutton9", profbars_inscription, "SecureActionButtonTemplate");
		insc_button9:SetHeight(35);
		insc_button9:SetWidth(35);
		insc_button9:SetScript("PreClick", profbars_preclick_insc9);
		insc_button9:RegisterForClicks("AnyUp");
		insc_button9:SetPoint("TOPLEFT", profbars_inscription, "TOPLEFT");
		insc_button9:SetNormalTexture("Interface\\Icons\\inv_inscription_pigment_white");
		insc_button9:SetHighlightTexture("Interface\\Icons\\inv_inscription_pigment_white", 1.5);
		insc_button9:SetScript("OnEnter", OnEnter);
		insc_button9:SetScript("OnLeave", OnLeave);
		local insc_movebutton = CreateFrame("Button", "profbars_inscmove", profbars_inscription);
		insc_movebutton:SetHeight(17.5);
		insc_movebutton:SetWidth(17.5);
		insc_movebutton:SetScript("OnMouseDown", profbars_startdragging_insc);
		insc_movebutton:SetScript("OnMouseUp", profbars_stopdragging_insc);
		insc_movebutton:SetPoint("TOPRIGHT", profbars_inscription, "TOPRIGHT");
		insc_movebutton:SetHighlightTexture("Interface\\Icons\\Spell_Arcane_PortalStormWind", 0.8);
		ProfessionBars:ScheduleTimer("ITEM_PUSH", 1);
		if profbars_data.mode == 2 then
			if IsAddOnLoaded("AdvancedTradeSkillWindow") then
				insc_bar:ClearAllPoints();
				insc_bar:SetPoint("TOP", ATSWFrame, "BOTTOM", 0, 10);
			else
				insc_bar:ClearAllPoints();
				insc_bar:SetPoint("TOP", TradeSkillFrame, "BOTTOMLEFT", 180, 75);
			end
			insc_movebutton:Hide();
			insc_bar:Hide();
		end
	end
	if PlayerHasSpell(2108) then
		--Leatherworking
	end
	if PlayerHasSpell(2575) then
		--Mining
	end
	if PlayerHasSpell(8613) then
		--Skinning
	end
	if PlayerHasSpell(3908) then
		--Tailoring
	end
end
